import React, { useState, useEffect } from 'react';
import AutoTable from '../../AutoTable';
import EditTable from '../EditTable';

function Expandables({ value, onChange, item }) {
  console.log(value);
  return (
    <div>
      <AutoTable
        columns={item?.columns}
        path={item?.path}
        extraparams={item?.extraparams}
        expandable={{
          expandedRowRender: (record) => {
            return (
              <div>
                <EditTable
                  resizeable={false}
                  alwaysShowAlert={false}
                  tableAlertRender={false}
                  tableAlertOptionRender={false}
                  columns={[
                    {
                      title: '线边库',
                      dataIndex: 'stockName',
                      search: false,
                      key: 'stockName',
                      editable: false,
                    },
                    {
                      title: '供应商编号',
                      dataIndex: 'supplierNo',
                      key: 'supplierNo',
                      search: false,
                      editable: false,
                    },
                    {
                      title: '供应商名称',
                      dataIndex: 'supplierName',
                      search: false,
                      key: 'supplierName',
                      editable: false,
                    },
                    {
                      title: '库存数量',
                      dataIndex: 'actualStock',
                      search: false,
                      key: 'actualStock',
                      editable: false,
                    },
                    {
                      title: '下架数量',
                      dataIndex: 'operateNum',
                      search: false,
                      key: 'operateNum',
                      valueType: 'digit',
                      fieldProps: {
                        precision: 3,
                      },
                    },
                  ]}
                  path={item?.expandablePath}
                  extraparams={{ lifePieceAccountId: record?.id }}
                  rowSelection={{
                    getCheckboxProps: (record) => ({
                      disabled: record.isAsh == '1',
                    }),
                    columnWidth: 44,
                    preserveSelectedRowKeys: true,
                    selectedRowKeys:
                      value && value.length > 0
                        ? value?.filter?.((it) => it?.lifePieceAccountId == record.id)[0]
                          ? value
                              ?.filter?.((it) => it?.lifePieceAccountId == record.id)[0]
                              ?.lineStockUseList?.map?.((it) => it?.lineStockId)
                          : []
                        : [],
                    onChange: (selectedKeys, selectedRows) => {
                      //   debugger;
                      const curval =
                        value?.filter?.((it) => it?.lifePieceAccountId == record.id)[0]
                          ?.lineStockUseList ?? [];
                      const rowkeylist =
                        curval && curval.length > 0 ? curval?.map((it) => it?.lineStockId) : [];
                      const newValue = selectedRows?.map((its) => {
                        if (rowkeylist?.includes(its?.id)) {
                          return curval?.filter((it) => it?.lineStockId == its?.id)[0];
                        } else {
                          return {
                            lineStockId: its.id,
                            operateNum: its.operateNum,
                          };
                        }
                      });
                      let nvalue = value ? [...value] : [];
                      if (value && value?.some((it) => it.lineStockId == record?.id)) {
                        nvalue = value?.map((it, i) => {
                          if (it.lineStockId == record.id) {
                            it.lineStockUseList = newValue;
                          }
                          return it;
                        });
                      } else {
                        nvalue.push({
                          id: record?.id,
                          lineStockUseList: newValue,
                        });
                      }
                      onChange(nvalue);
                    },
                  }}
                  editable={{
                    onValuesChange: (rower, recordList) => {
                      console.log(rower);
                      const curval =
                        value?.filter?.((it) => it?.lifePieceAccountId == record.id)[0]
                          ?.lineStockUseList ?? [];
                      const newValue = curval?.map((its) => {
                        if (its?.lineStockId == rower?.id) {
                          return {
                            lineStockId: rower.id,
                            operateNum: rower.operateNum,
                          };
                        } else {
                          return its;
                        }
                      });
                      let nvalue = value ? [...value] : [];
                      if (value && value?.some((it) => it.id == record?.id)) {
                        nvalue = value?.map((it, i) => {
                          if (it.id == record.id) {
                            it.lineStockUseList = newValue;
                          }
                          return it;
                        });
                      } else {
                        nvalue.push({
                          id: record.id,
                          lineStockUseList: newValue,
                        });
                      }
                      onChange(nvalue);
                    },
                    onExpandedRowsChange: (expandedRows) => {
                      console.log(expandedRows);
                    },
                  }}
                />
              </div>
            );
          },
        }}
      />
    </div>
  );
}

export default Expandables;
